<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Danh sách người dùng đăng kí</title>

    <!-- Google Font: Source Sans Pro -->
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
    <!-- Font Awesome -->
    <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css">
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">

    <!-- jQuery -->
    <script src="plugins/jquery/jquery.min.js "></script>
    <!-- Bootstrap 4 -->
    <script src="plugins/bootstrap/js/bootstrap.bundle.min.js "></script>
    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.js "></script>

    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js "></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js "></script>
</head>

<body class="hold-transition sidebar-mini layout-fixed" onload="onPageLoading()">
    <div class=" wrapper">
        <nav class="main-header navbar navbar-expand navbar-white navbar-light ">
            <!-- Left navbar links -->
            <ul class="navbar-nav ">
                <li class="nav-item ">
                    <a class="nav-link " data-widget="pushmenu " href="# " role="button "><i class="fas fa-bars "></i></a>
                </li>
                <li class="nav-item d-none d-sm-inline-block ">
                    <a href="# " class="nav-link ">Danh sách người dùng đăng kí</a>
                </li>
            </ul>

            <!-- Right navbar links -->
            <ul class="navbar-nav ml-auto ">

                <!-- Notifications Dropdown Menu -->
                <li class="nav-item ">
                    <a class="nav-link " data-widget="fullscreen " href="# " role="button ">
                        <i class="fas fa-expand-arrows-alt "></i>
                    </a>
                </li>
            </ul>
        </nav>
        <aside class="main-sidebar sidebar-dark-primary elevation-4 ">
            <!-- Brand Logo -->
            <a href="# " class="brand-link ">
                <span class="brand-text font-weight-light ">Task 45.</span>
            </a>
            <!-- Sidebar -->
            <div class="sidebar ">

                <!-- Sidebar Menu -->
                <nav class="mt-2 ">
                    <ul class="nav nav-pills nav-sidebar flex-column " data-widget="treeview " role="menu " data-accordion="false ">
                        <!-- Add icons to the links using the .nav-icon class
                       with font-awesome or any other icon font library -->
                        <li class="nav-item menu-open ">
                            <a href="# " class="nav-link active ">
                                <i class="nav-icon fas fa-tachometer-alt "></i>
                                <p>
                                    Dashboard
                                    <i class="right fas fa-angle-left "></i>
                                </p>
                            </a>
                            <ul class="nav nav-treeview ">
                                <li class="nav-item ">
                                    <a href="./index1.html " class="nav-link">
                                        <i class="far fa-circle nav-icon "></i>
                                        <p>Dashboard v1</p>
                                    </a>
                                </li>
                                <li class="nav-item ">
                                    <a href="./index2.html " class="nav-link active">
                                        <i class="far fa-circle nav-icon "></i>
                                        <p>Dashboard v2</p>
                                    </a>
                                </li>
                                <li class="nav-item ">
                                    <a href="./index3.html " class="nav-link ">
                                        <i class="far fa-circle nav-icon "></i>
                                        <p>Dashboard v3</p>
                                    </a>
                                </li>
                            </ul>
                        </li>
                        <li class="nav-item ">
                            <a href="pages/widgets.html " class="nav-link ">
                                <i class="nav-icon fas fa-th "></i>
                                <p>
                                    Widgets
                                    <span class="right badge badge-danger ">New</span>
                                </p>
                            </a>
                    </ul>
                </nav>
                <!-- /.sidebar-menu -->
            </div>
            <!-- /.sidebar -->
        </aside>
        <!-- Content Wrapper. Contains page content -->
        <div class="content-wrapper ">
            <!-- Content Header (Page header) -->
            <div class="content-header ">
                <div class="container ">
                    <div class="text-center ">
                        <h2>Danh sách người dùng đăng kí</h2>
                    </div>
                    <button class="btn btn-success form-group" id="btn-them" data-toggle="modal" data-target="#insert-user-modal">Thêm User</button>
                </div>
            </div>
            <section class="content ">
                <table id="table-users" class="table table-bordered table-striped table-hover text-center font-weight-bold">
                    <thead>
                        <tr>
                            <td>ID</td>
                            <td>Firstname</td>
                            <td>Lastname</td>
                            <td>Country</td>
                            <td>Subject</td>
                            <td>Customer Type</td>
                            <td>Register Status</td>
                            <td>Action</td>
                        </tr>
                    </thead>
                    <tbody>

                    </tbody>
                </table>

        </div>
        <div id="insert-user-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title">Thêm User</h5>
                        <button type="button" class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>First Name</label>
                            </div>
                            <div class="col-sm-8">
                                <input id="inp-firstname" class="form-control">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Last Name</label>
                            </div>
                            <div class="col-sm-8">
                                <input id="inp-lastname" class="form-control">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Subject</label>
                            </div>
                            <div class="col-sm-8">
                                <input id="inp-subject" class="form-control">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Country</label>
                            </div>
                            <div class="col-sm-8">
                                <select class="form-control" id="sel-country">
                                        <option value="NOT">Select Country</option>
                                        <option value="VN">Việt Nam</option>
                                        <option value="USA">USA</option>
                                        <option value="AUS">Australia</option>
                                        <option value="CAN">CANADA</option>
                                    </select>
                            </div>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button id="btn-insert" class="btn btn-success">Insert User</button>
                        <button id="btn-cancel" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                    </div>
                </div>
            </div>
        </div>
        <div id="edit-user-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title">Chi tiết User</h5>
                        <button type="button" class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>First Name</label>
                            </div>
                            <div class="col-sm-8">
                                <input id="inp-firstname-edit" class="form-control">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Last Name</label>
                            </div>
                            <div class="col-sm-8">
                                <input id="inp-lastname-edit" class="form-control">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Subject</label>
                            </div>
                            <div class="col-sm-8">
                                <input id="inp-subject-edit" class="form-control">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Country</label>
                            </div>
                            <div class="col-sm-8">
                                <select class="form-control" id="sel-country-edit">
                                        <option value="NOT">Select Country</option>
                                        <option value="VN">Việt Nam</option>
                                        <option value="USA">USA</option>
                                        <option value="AUS">Australia</option>
                                        <option value="CAN">CANADA</option>
                                    </select>
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Customer Type</label>
                            </div>
                            <div class="col-sm-8">
                                <select class="form-control" id="sel-customer-edit">
                                        <option value="NOT">Select Type</option>
                                        <option value="Gold">Gold</option>
                                        <option value="Premium">Premium</option>
                                        <option value="Standard">Standard</option>
                                    </select>
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Register Status</label>
                            </div>
                            <div class="col-sm-8">
                                <select class="form-control" id="sel-register-edit">
                                        <option value="NOT">Select Status</option>
                                        <option value="Accepted">Accepted</option>
                                        <option value="Denied">Denied</option>
                                        <option value="Standard">Standard</option>
                                    </select>
                            </div>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button id="btn-update" class="btn btn-success">Update User</button>
                        <button id="btn-cancel-edit" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                    </div>
                </div>
            </div>
        </div>
        <div id="delete-user-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title">Confirm xóa User</h5>
                        <button type="button" class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body text-center">
                        <div class="row form-group">
                            <div class="col-sm-12 text-center font-weight-bold">
                                <label>Bạn có chắc muốn xóa user này không?</label>
                            </div>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button id="btn-xacnhan" class="btn btn-danger">Xác nhận</button>
                        <button id="btn-huybo" class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
    </section>
    </div>
    <!-- /.content-wrapper -->
    <footer class="main-footer ">
        <strong>Copyright &copy; 2022 User list Devcamp</strong> All rights reserved.
        <div class="float-right d-none d-sm-inline-block ">
            <b>Version</b> 1.0.0
        </div>
    </footer>
    </div>

    <script>
        "use strict";
        const gCountry = [{
            "value": "VN",
            "text": "Việt Nam"
        }, {
            "value": "USA",
            "text": "Mỹ"
        }, {
            "value": "AUS",
            "text": "Australia"
        }, {
            "value": "CAN",
            "text": "Canada"
        }]
        const gUser = ["id", "firstname", "lastname", "country", "subject", "customerType", "registerStatus", "action"]
        const gID_col = 0;
        var gID = "";
        const gFirstname_col = 1;
        const gLastname_col = 2;
        const gCountry_col = 3;
        const gSubject_col = 4;
        const gCustomerType_col = 5;
        const gRegisterStatus_col = 6;
        const gAction_col = 7;
        $("#table-users").DataTable({
            columns: [{
                data: gUser[gID_col]
            }, {
                data: gUser[gFirstname_col]
            }, {
                data: gUser[gLastname_col]
            }, {
                data: gUser[gCountry_col]
            }, {
                data: gUser[gSubject_col]
            }, {
                data: gUser[gCustomerType_col]
            }, {
                data: gUser[gRegisterStatus_col]
            }, {
                data: gUser[gAction_col]
            }, ],
            columnDefs: [{
                targets: gCountry_col,
                render: function(data) {
                    return getTextByValueCountry(data);
                }
            }, {
                targets: gAction_col,
                className: "text-center",
                defaultContent: "<button class='btn btn-success btn-edit'>Sửa</button><button class='btn btn-danger btn-delete'>Xóa</button>"
            }],
            autoWidth: false
        })
        var gList = [];
        $(document).ready(function() {
            onPageLoading();
            $("#btn-them").on("click", function() {
                onBtnAddUserClick();
            })
            $("#btn-insert").on("click", function() {
                onBtnCreatUserClick();
            })
            $("#btn-update").on("click", function() {
                onBtnUpdatetUserClick();
            })
        });

        function onPageLoading() {
            "use strict";
            getUsers();
            loadDataToTable(gList);
        }

        function getUsers() {
            "use strict";
            $.ajax({
                url: "http://42.115.221.44:8080/crud-api/users/",
                async: false,
                dateType: "json",
                success: function(res) {
                    gList = res;
                    console.log(res);
                },
                error: function(error) {
                    console.log(error.responseText)
                }
            })
        }

        function getTextByValueCountry(paramCountry) {
            "use strict";
            var vText = "";
            for (var i = 0; i < gCountry.length; i++) {
                if (gCountry[i].value == paramCountry) {
                    vText = gCountry[i].text;
                }
            };
            return vText;
        }

        function loadDataToTable(paramList) {
            "use strict";
            var vTable = $("#table-users").DataTable();
            vTable.clear();
            vTable.rows.add(paramList);
            vTable.draw();
        }
        $(document).on("click", ".btn-edit", function() {
            console.log("Đã click nút sửa");
            onBtnClick(this);
            $("#edit-user-modal").modal("show");
            onBtnEditClick(this);

        })
        $(document).on("click", ".btn-delete", function() {
            console.log("Đã click nút xóa");
            onBtnClick(this);
            onBtnDeleteUserClick();
        })


        function onBtnClick(paramthis) {
            "use strict";
            var vRow = $(paramthis).closest("tr"); //xác định tr chứa nút click
            var vTable = $("#table-users").DataTable();
            var vData = vTable.row(vRow).data();
            console.log("ID là :" + vData.id);
            gID = vData.id;
            return vData;
            console.log("gID là " + gID);
        }

        function onBtnAddUserClick() {
            "use strict";
            console.log("Đã click nút Thêm User");
        }

        function onBtnCreatUserClick() {
            "use strict";
            var vInfo = {
                firstname: "",
                lastname: "",
                subject: "",
                country: ""
            }
            getInfoFromCreat(vInfo);
            var vCheck = checkInfo(vInfo);
            if (vCheck) {
                console.log(vInfo);
                InsertUserByPostAPI(vInfo);
                getUsers();
                loadDataToTable(gList);
                resertModal();
                $("insert-user-modal").modal("hide");
            }
        }

        function getInfoFromCreat(paramInfo) {
            "use strict";
            paramInfo.firstname = $.trim($("#inp-firstname").val());
            paramInfo.lastname = $.trim($("#inp-lastname").val());
            paramInfo.subject = $.trim($("#inp-subject").val());
            paramInfo.country = $("#sel-country").val()
        }

        function checkInfo(paramInfo) {
            "use strict";
            if (paramInfo.firstname == "") {
                alert("Xin vui lòng nhập First name");
                return false;
            }
            if (paramInfo.lastname == "") {
                alert("Xin vui lòng nhập Last name");
                return false;
            }
            if (paramInfo.subject == "") {
                alert("Xin vui lòng nhập Subject");
                return false;
            }
            if (paramInfo.country == "NOT") {
                alert("Xin vui lòng chọn Country");
                return false;
            }
            return true;
        }

        function InsertUserByPostAPI(paramInfo) {
            "use strict";
            $.ajax({
                async: false,
                url: "http://42.115.221.44:8080/crud-api/users/",
                type: "POST",
                data: JSON.stringify(paramInfo),
                contentType: "application/json",
                success: function(res) {
                    console.log(res);
                    alert("Đã thêm User thành công");
                },
                error: function(error) {
                    alert(error.responseText);
                }
            })
        }

        function resertModal() {
            $("#inp-firstname").val("");
            $("#inp-lastname").val("");
            $("#inp-subject").val("");
            $("#sel-country").val("NOT");
        }

        function onBtnEditClick(paramthis) {
            "use strict";
            var vRowUser = onBtnClick(paramthis);
            // var vRowUser = gID;
            $("#inp-firstname-edit").val(vRowUser.firstname);
            $("#inp-lastname-edit").val(vRowUser.lastname);
            $("#inp-subject-edit").val(vRowUser.subject);
            $("#sel-country-edit").val(vRowUser.country);
            $("#sel-customer-edit").val(vRowUser.customerType);
            $("#sel-register-edit").val(vRowUser.registerStatus);

        }

        function onBtnUpdatetUserClick() {
            "use strict";
            var vUserUpdate = {
                firstname: "",
                lastnme: "",
                subject: "",
                country: "",
                customerType: "",
                registerStatus: "",
            }
            getInfoFromUpdate(vUserUpdate);
            var vCheck = checkUserUpdate(vUserUpdate);
            if (vCheck) {
                UpdateUser(vUserUpdate);
                loadDataToTable(gList);
                resertUpdateUser();
                $("#edit-user-modal").modal("hide");
            }
        }

        function getInfoFromUpdate(paramUpdate) {
            paramUpdate.firstname = $.trim($("#inp-firstname-edit").val());
            paramUpdate.lastname = $.trim($("#inp-lastname-edit").val());
            paramUpdate.subject = $.trim($("#inp-subject-edit").val());
            paramUpdate.country = $("#sel-country-edit").val();
            paramUpdate.customerType = $("#sel-customer-edit").val();
            paramUpdate.registerStatus = $("#sel-register-edit").val();
        }

        function checkUserUpdate(paramUpdate) {
            if (paramUpdate.firstname == "") {
                alert("Xin vui lòng nhập First name");
                return false;
            }
            if (paramUpdate.lastname == "") {
                alert("Xin vui lòng nhập Last name");
                return false;
            }
            if (paramUpdate.subject == "") {
                alert("Xin vui lòng nhập Subject");
                return false;
            }
            if (paramUpdate.country == "NOT") {
                alert("Xin vui lòng chọn Country");
                return false;
            }
            if (paramUpdate.customerType == "NOT") {
                alert("Xin vui lòng chọn Customer Type");
                return false;
            }
            if (paramUpdate.registerStatus == "NOT") {
                alert("Xin vui lòng chọn Register Status");
                return false;
            }
            return true;
        }

        function UpdateUser(paramUpdate) {
            "use strict";
            console.log("OK updated");
            console.log(paramUpdate);
            var vJSonString = JSON.stringify(paramUpdate);
            $.ajax({
                url: "http://42.115.221.44:8080/crud-api/users/" + gID,
                method: "PUT",
                contentType: "application/json;charset=utf-8",
                data: vJSonString,
                success: function(res) {
                    alert("User ID: " + res.id + "\n Cập nhật thành công!");
                    window.location.href = "Task 37.50.html";
                },
                error: function(error) {
                    alert(error);
                }
            })
        }

        function resertUpdateUser() {
            "use strict";
            $("#inp-firstname-edit").val("");
            $("#inp-lastname-edit").val("");
            $("#inp-subject-edit").val("");
            $("#sel-country-edit").val("NOT");
            $("#sel-customerType-edit").val("NOT");
            $("#sel-registerStatus-edit").val("NOT");
        }

        function onBtnDeleteUserClick() {
            $("#delete-user-modal").modal("show");
            $("#btn-xacnhan").on("click", function() {
                onBtnConfirmDelele();
            })
        }

        function onBtnConfirmDelele() {
            $.ajax({
                url: "http://42.115.221.44:8080/crud-api/users/" + gID,
                method: "DELETE",
                contentType: "application/json;charset=utf-8",
                success: function(res) {
                    alert("User ID: " + gID + "\n Đã xóa User thành công!");
                    $("#delete-user-modal").modal("hide");
                    window.location.href = "Task 37.50.html";
                },
                error: function(error) {
                    alert(error.responseText);
                }
            })
        }
    </script>
</body>


</html>